> ## Documentation Index
> Fetch the complete documentation index at: https://docs.apimart.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Video (이미지→동영상)

> Midjourney 이미지→동영상(i2v). 고정 FAST, t2v 미지원, 길이 약 5초

<RequestExample>
  ```bash cURL theme={null}
  curl --request POST \
    --url https://api.apimart.ai/v1/midjourney/generations/video \
    --header 'Authorization: Bearer <token>' \
    --header 'Content-Type: application/json' \
    --data '{
      "prompt": "the cat slowly turns its head to the camera",
      "image_urls": [
        "https://example.com/cat.png"
      ],
      "motion": "high",
      "batch_size": 4
    }'
  ```

  ```python Python theme={null}
  import requests

  url = "https://api.apimart.ai/v1/midjourney/generations/video"

  payload = {
      "prompt": "the cat slowly turns its head to the camera",
      "image_urls": [
          "https://example.com/cat.png"
      ],
      "motion": "high",
      "batch_size": 4
  }

  headers = {
      "Authorization": "Bearer <token>",
      "Content-Type": "application/json"
  }

  response = requests.post(url, json=payload, headers=headers)

  print(response.json())
  ```

  ```javascript JavaScript theme={null}
  const url = "https://api.apimart.ai/v1/midjourney/generations/video";

  const payload = {
    prompt: "the cat slowly turns its head to the camera",
    image_urls: [
      "https://example.com/cat.png"
    ],
    motion: "high",
    batch_size: 4
  };

  const headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
  };

  fetch(url, {
    method: "POST",
    headers: headers,
    body: JSON.stringify(payload)
  })
    .then(response => response.json())
    .then(data => console.log(data))
    .catch(error => console.error('Error:', error));
  ```

  ```go Go theme={null}
  package main

  import (
      "bytes"
      "encoding/json"
      "fmt"
      "io/ioutil"
      "net/http"
  )

  func main() {
      url := "https://api.apimart.ai/v1/midjourney/generations/video"

      payload := map[string]interface{}{
          "prompt": "the cat slowly turns its head to the camera",
          "image_urls": []string{
              "https://example.com/cat.png",
          },
          "motion": "high",
          "batch_size": 4,
      }

      jsonData, _ := json.Marshal(payload)

      req, _ := http.NewRequest("POST", url, bytes.NewBuffer(jsonData))
      req.Header.Set("Authorization", "Bearer <token>")
      req.Header.Set("Content-Type", "application/json")

      client := &http.Client{}
      resp, err := client.Do(req)
      if err != nil {
          panic(err)
      }
      defer resp.Body.Close()

      body, _ := ioutil.ReadAll(resp.Body)
      fmt.Println(string(body))
  }
  ```

  ```java Java theme={null}
  import java.net.http.HttpClient;
  import java.net.http.HttpRequest;
  import java.net.http.HttpResponse;
  import java.net.URI;

  public class Main {
      public static void main(String[] args) throws Exception {
          String url = "https://api.apimart.ai/v1/midjourney/generations/video";

          String payload = """
          {
            "prompt": "the cat slowly turns its head to the camera",
            "image_urls": [
              "https://example.com/cat.png"
            ],
            "motion": "high",
            "batch_size": 4
          }
          """;

          HttpClient client = HttpClient.newHttpClient();
          HttpRequest request = HttpRequest.newBuilder()
              .uri(URI.create(url))
              .header("Authorization", "Bearer <token>")
              .header("Content-Type", "application/json")
              .POST(HttpRequest.BodyPublishers.ofString(payload))
              .build();

          HttpResponse<String> response = client.send(request,
              HttpResponse.BodyHandlers.ofString());

          System.out.println(response.body());
      }
  }
  ```

  ```php PHP theme={null}
  <?php

  $url = "https://api.apimart.ai/v1/midjourney/generations/video";

  $payload = [
      "prompt" => "the cat slowly turns its head to the camera",
      "image_urls" => [
          "https://example.com/cat.png",
      ],
      "motion" => "high",
      "batch_size" => 4,
  ];

  $ch = curl_init($url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($ch, CURLOPT_POST, true);
  curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($payload));
  curl_setopt($ch, CURLOPT_HTTPHEADER, [
      "Authorization: Bearer <token>",
      "Content-Type: application/json"
  ]);

  $response = curl_exec($ch);
  curl_close($ch);

  echo $response;
  ?>
  ```

  ```ruby Ruby theme={null}
  require 'net/http'
  require 'json'
  require 'uri'

  url = URI("https://api.apimart.ai/v1/midjourney/generations/video")

  payload = {
    prompt: "the cat slowly turns its head to the camera",
    image_urls: [
      "https://example.com/cat.png",
    ],
    motion: "high",
    batch_size: 4,
  }

  http = Net::HTTP.new(url.host, url.port)
  http.use_ssl = true

  request = Net::HTTP::Post.new(url)
  request["Authorization"] = "Bearer <token>"
  request["Content-Type"] = "application/json"
  request.body = payload.to_json

  response = http.request(request)
  puts response.body
  ```

  ```swift Swift theme={null}
  import Foundation

  let url = URL(string: "https://api.apimart.ai/v1/midjourney/generations/video")!

  let payload: [String: Any] = [
      "prompt": "the cat slowly turns its head to the camera",
      "image_urls": [
          "https://example.com/cat.png",
      ],
      "motion": "high",
      "batch_size": 4,
  ]

  var request = URLRequest(url: url)
  request.httpMethod = "POST"
  request.setValue("Bearer <token>", forHTTPHeaderField: "Authorization")
  request.setValue("application/json", forHTTPHeaderField: "Content-Type")
  request.httpBody = try? JSONSerialization.data(withJSONObject: payload)

  let task = URLSession.shared.dataTask(with: request) { data, response, error in
      if let error = error {
          print("Error: \(error)")
          return
      }
      
      if let data = data, let responseString = String(data: data, encoding: .utf8) {
          print(responseString)
      }
  }

  task.resume()
  ```

  ```csharp C# theme={null}
  using System;
  using System.Net.Http;
  using System.Text;
  using System.Threading.Tasks;

  class Program
  {
      static async Task Main(string[] args)
      {
          var url = "https://api.apimart.ai/v1/midjourney/generations/video";

          var payload = @"{
              ""prompt"": ""the cat slowly turns its head to the camera"",
              ""image_urls"": [
                  ""https://example.com/cat.png""
              ],
              ""motion"": ""high"",
              ""batch_size"": 4
          }";

          using var client = new HttpClient();
          client.DefaultRequestHeaders.Add("Authorization", "Bearer <token>");

          var content = new StringContent(payload, Encoding.UTF8, "application/json");
          var response = await client.PostAsync(url, content);
          var result = await response.Content.ReadAsStringAsync();

          Console.WriteLine(result);
      }
  }
  ```

  ```c C theme={null}
  #include <stdio.h>
  #include <curl/curl.h>

  int main(void) {
      CURL *curl;
      CURLcode res;

      curl_global_init(CURL_GLOBAL_DEFAULT);
      curl = curl_easy_init();

      if(curl) {
          const char *url = "https://api.apimart.ai/v1/midjourney/generations/video";
          const char *payload = "{"
              "\"prompt\":\"the cat slowly turns its head to the camera\","
              "\"image_urls\":[\"https://example.com/cat.png\"],"
              "\"motion\":\"high\","
              "\"batch_size\":4"
          "}";

          struct curl_slist *headers = NULL;
          headers = curl_slist_append(headers, "Authorization: Bearer <token>");
          headers = curl_slist_append(headers, "Content-Type: application/json");

          curl_easy_setopt(curl, CURLOPT_URL, url);
          curl_easy_setopt(curl, CURLOPT_POSTFIELDS, payload);
          curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);

          res = curl_easy_perform(curl);

          if(res != CURLE_OK) {
              fprintf(stderr, "curl_easy_perform() failed: %s\n",
                      curl_easy_strerror(res));
          }

          curl_slist_free_all(headers);
          curl_easy_cleanup(curl);
      }

      curl_global_cleanup();
      return 0;
  }
  ```

  ```objectivec Objective-C theme={null}
  #import <Foundation/Foundation.h>

  int main(int argc, const char * argv[]) {
      @autoreleasepool {
          NSURL *url = [NSURL URLWithString:@"https://api.apimart.ai/v1/midjourney/generations/video"];
          
          NSDictionary *payload = @{
              @"prompt": @"the cat slowly turns its head to the camera",
              @"image_urls": @[
                  @"https://example.com/cat.png",
              ],
              @"motion": @"high",
              @"batch_size": @4,
          };
          
          NSError *error;
          NSData *jsonData = [NSJSONSerialization dataWithJSONObject:payload
                                                            options:0
                                                              error:&error];
          
          NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url];
          [request setHTTPMethod:@"POST"];
          [request setValue:@"Bearer <token>" forHTTPHeaderField:@"Authorization"];
          [request setValue:@"application/json" forHTTPHeaderField:@"Content-Type"];
          [request setHTTPBody:jsonData];
          
          NSURLSessionDataTask *task = [[NSURLSession sharedSession] 
              dataTaskWithRequest:request
              completionHandler:^(NSData *data, NSURLResponse *response, NSError *error) {
                  if (error) {
                      NSLog(@"Error: %@", error);
                      return;
                  }
                  NSString *result = [[NSString alloc] initWithData:data 
                                                          encoding:NSUTF8StringEncoding];
                  NSLog(@"%@", result);
              }];
          
          [task resume];
          [[NSRunLoop mainRunLoop] run];
      }
      return 0;
  }
  ```

  ```ocaml OCaml theme={null}
  (* Requires cohttp and yojson libraries *)
  open Lwt
  open Cohttp
  open Cohttp_lwt_unix

  let url = "https://api.apimart.ai/v1/midjourney/generations/video"

  let payload = {|{
    "prompt": "the cat slowly turns its head to the camera",
    "image_urls": [
      "https://example.com/cat.png"
    ],
    "motion": "high",
    "batch_size": 4
  }|}

  let () =
    let headers = Header.init ()
      |> fun h -> Header.add h "Authorization" "Bearer <token>"
      |> fun h -> Header.add h "Content-Type" "application/json"
    in
    let body = Cohttp_lwt.Body.of_string payload in
    
    let response = Client.post ~headers ~body (Uri.of_string url) >>= fun (resp, body) ->
      body |> Cohttp_lwt.Body.to_string >|= fun body_str ->
      print_endline body_str
    in
    Lwt_main.run response
  ```

  ```dart Dart theme={null}
  import 'dart:convert';
  import 'package:http/http.dart' as http;

  void main() async {
    final url = Uri.parse('https://api.apimart.ai/v1/midjourney/generations/video');
    
    final payload = {
      'prompt': 'the cat slowly turns its head to the camera',
      'image_urls': [
        'https://example.com/cat.png',
      ],
      'motion': 'high',
      'batch_size': 4,
    };
    
    final response = await http.post(
      url,
      headers: {
        'Authorization': 'Bearer <token>',
        'Content-Type': 'application/json',
      },
      body: jsonEncode(payload),
    );
    
    print(response.body);
  }
  ```

  ```r R theme={null}
  library(httr)
  library(jsonlite)

  url <- "https://api.apimart.ai/v1/midjourney/generations/video"

  payload <- list(
    prompt = "the cat slowly turns its head to the camera",
    image_urls = list(
      "https://example.com/cat.png"
    ),
    motion = "high",
    batch_size = 4
  )

  response <- POST(
    url,
    add_headers(
      Authorization = "Bearer <token>",
      `Content-Type` = "application/json"
    ),
    body = toJSON(payload, auto_unbox = TRUE),
    encode = "raw"
  )

  cat(content(response, "text"))
  ```
</RequestExample>

<ResponseExample>
  ```json 200 theme={null}
  {
    "code": 200,
    "data": [
      {
        "status": "submitted",
        "task_id": "task_01KV52C0TEJSYZMCG0NCS4YWKK"
      }
    ]
  }
  ```

  ```json 400 theme={null}
  {
    "error": {
      "code": 400,
      "message": "잘못된 요청 매개변수입니다",
      "type": "invalid_request_error"
    }
  }
  ```

  ```json 401 theme={null}
  {
    "error": {
      "code": 401,
      "message": "인증 정보가 유효하지 않습니다",
      "type": "authentication_error"
    }
  }
  ```

  ```json 402 theme={null}
  {
    "error": {
      "code": 402,
      "message": "잔액이 부족합니다. 계정에 충전해주세요",
      "type": "payment_required"
    }
  }
  ```

  ```json 403 theme={null}
  {
    "error": {
      "code": 403,
      "message": "접근이 금지되었습니다. 이 리소스에 대한 권한이 없습니다",
      "type": "permission_error"
    }
  }
  ```

  ```json 404 theme={null}
  {
    "error": {
      "code": 404,
      "message": "작업을 찾을 수 없습니다",
      "type": "not_found_error"
    }
  }
  ```

  ```json 422 theme={null}
  {
    "error": {
      "code": 422,
      "message": "이미지 또는 프롬프트가 콘텐츠 검수를 통과하지 못했습니다(자동 환불됨)",
      "type": "invalid_request_error"
    }
  }
  ```

  ```json 429 theme={null}
  {
    "error": {
      "code": 429,
      "message": "요청 한도를 초과했습니다. 나중에 다시 시도해주세요",
      "type": "rate_limit_error"
    }
  }
  ```

  ```json 500 theme={null}
  {
    "error": {
      "code": 500,
      "message": "내부 서버 오류가 발생했습니다. 나중에 다시 시도해주세요",
      "type": "server_error"
    }
  }
  ```

  ```json 502 theme={null}
  {
    "error": {
      "code": 502,
      "message": "불량 게이트웨이입니다. 서버가 일시적으로 사용할 수 없습니다",
      "type": "bad_gateway"
    }
  }
  ```
</ResponseExample>

이미지에서 동영상 생성(i2v). **고정 FAST 모드이며 speed 차원이 없습니다**. **텍스트→동영상(t2v)은 지원하지 않으며** 첫 프레임이 필수입니다. 길이는 약 5초로 고정됩니다.

| 항목     | 내용                                                                          |
| ------ | --------------------------------------------------------------------------- |
| action | `VIDEO`                                                                     |
| 과금     | `midjourney@video` / `midjourney@video-720p`, **실제 청구 = 단가 × `batch_size`** |
| 필수     | `image_urls`(첫 프레임) 또는 `task_id`(SUCCESS인 imagine 재사용)                      |

## 파라미터

| 필드             | 타입        | 필수  | 기본값               | 설명                                                     |
| -------------- | --------- | --- | ----------------- | ------------------------------------------------------ |
| `prompt`       | string    | 아니오 | (부모 상속)           | 동영상 프롬프트. 비우면 `task_id` 필수                             |
| `image_urls`   | string\[] | △   | —                 | 첫 프레임(1장, ≤ 12 MiB). `task_id`와 둘 중 하나                 |
| `task_id`      | string    | △   | —                 | SUCCESS인 imagine 재사용. `image_urls`와 둘 중 하나             |
| `index`        | int       | 아니오 | —                 | imagine 4장 중 어느 것을 첫 프레임으로 할지(`0`\~`3`, `task_id`와 함께) |
| `video_type`   | string    | 아니오 | `vid_1.1_i2v_480` | 해상도 등급(아래 표). `720` 포함 시 `@video-720p` 과금              |
| `animate_mode` | string    | 아니오 | `manual`          | `manual` / `auto`. `auto`는 `task_id` + `index` 필수      |
| `motion`       | string    | 아니오 | `high`            | `low` / `high`. 모션 정도, **과금 영향 없음**                    |
| `batch_size`   | int       | 아니오 | `1`               | `1` / `2` / `4` 중 하나, 그 외 값은 1로 처리. **과금 × N**         |
| `end_url`      | string    | 아니오 | —                 | 종료 프레임. 설정 시 `video_type`이 자동으로 `start_end_*`로 승격      |

## video\_type 유효값

| 값                           | 해상도  | 모드                              | 과금                      |
| --------------------------- | ---- | ------------------------------- | ----------------------- |
| `vid_1.1_i2v_480`           | 480p | 기본 i2v(기본값)                     | `midjourney@video`      |
| `vid_1.1_i2v_720`           | 720p | 기본 i2v                          | `midjourney@video-720p` |
| `vid_1.1_i2v_start_end_480` | 480p | 시작/종료 프레임(`end_url` 설정 시 자동 승격) | `midjourney@video`      |
| `vid_1.1_i2v_start_end_720` | 720p | 시작/종료 프레임(`end_url` 설정 시 자동 승격) | `midjourney@video-720p` |

> `extend` 계열 값은 허용되지 않습니다. 위 표에 나열된 `video_type`만 지원합니다.

## 요청 예시

간단한 i2v(자체 첫 프레임, batch 4):

```json theme={null}
{
  "prompt": "the cat slowly turns its head to the camera",
  "image_urls": ["https://example.com/cat.png"],
  "motion": "high",
  "batch_size": 4
}
```

시작/종료 transition(`end_url`로 자동 `start_end` 승격):

```json theme={null}
{
  "prompt": "transition smoothly from sunrise to sunset",
  "image_urls": ["https://example.com/sunrise.jpg"],
  "end_url": "https://example.com/sunset.jpg",
  "video_type": "vid_1.1_i2v_720"
}
```

## 응답

제출 시 `task_id`를 반환하며 `GET /v1/tasks/{task_id}`를 폴링합니다. SUCCESS 시 `video_url`(첫 번째)과 `video_urls`(`length === batch_size`, batch=1이어도 1개 요소)를 포함합니다:

```json theme={null}
{
  "id": "task_xxx",
  "status": "SUCCESS",
  "action": "VIDEO",
  "mode": "FAST",
  "video_url": "https://r2.example.com/video-0.mp4",
  "video_urls": [
    "https://r2.example.com/video-0.mp4",
    "https://r2.example.com/video-1.mp4"
  ]
}
```

## 참고

* **텍스트→동영상(t2v)은 지원하지 않습니다**: `image_urls` 또는 `task_id`가 필수이며, 없으면 `400`을 반환합니다. 둘 다 전달할 수는 없습니다.
* **고정 FAST 모드**이며 speed 차원이 없습니다(과금 표의 `@video-fast` / `@video-turbo`는 절대 매칭되지 않음).
* `batch_size`는 `1` / `2` / `4`로 엄격히 검증됩니다. **batch=4는 4배 청구되므로 예산에 민감하면 batch=1을 사용하세요**.
* `animate_mode=auto`는 `task_id` + `index`가 모두 필요합니다.
* 첫 / 종료 프레임은 각각 ≤ 12 MiB.
